Index: trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc	(revision 3680)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrationChargeCalc.cc	(revision 3681)
@@ -1031,6 +1031,6 @@
         }
       
-      const Float_t photons    = avphotonflux / fGeom->GetPixRatio(i);
-      const Float_t conv       = photons      / pix.GetPheFFactorMethod();
+      const Float_t photons = avphotonflux / fGeom->GetPixRatio(i);
+      const Float_t qe      = pix.GetPheFFactorMethod() / photons ;
 
       if (!pix.CalcMeanFFactor( photons , avfluxrelvar ))
@@ -1041,8 +1041,8 @@
         }
 
-      const Float_t convrelvar = avfluxrelvar +  pix.GetPheFFactorMethodRelVar();
-
-      qepix.SetQEFFactor    ( conv                    , fPulserColor );
-      qepix.SetQEFFactorVar ( convrelvar * conv * conv, fPulserColor );      
+      const Float_t qerelvar = avfluxrelvar +  pix.GetPheFFactorMethodRelVar();
+
+      qepix.SetQEFFactor    ( qe            , fPulserColor );
+      qepix.SetQEFFactorVar ( qerelvar*qe*qe, fPulserColor );      
       qepix.UpdateFFactorMethod();
     }
Index: trunk/MagicSoft/Mars/mcalib/MCalibrationQECam.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrationQECam.cc	(revision 3680)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrationQECam.cc	(revision 3681)
@@ -30,24 +30,34 @@
 // Storage container for the calibrated Quantum Efficiency of the whole camera.
 //
+// For a complete description of the quantum efficiency calibration process, 
+// see MCalibrationQEPix.
+//
 // Individual pixels have to be cast when retrieved e.g.:
 // MCalibrationQEPix &avpix = (MCalibrationQEPix&)(*fQECam)[i]
 // 
-// The following "calibration" constants can be retrieved from each pixel:
-// - GetQE   ( const PulserColor_t color ): The mean quantum 
-//   efficiency obtained with the calibration pulser color (e.g. kGREEN, kBLUE, kUV)
-// - GetQEErr( const PulserColor_t color ): The uncertainty 
-//   of the mean quantum efficiency.
-//
 // Averaged values over one whole area index (e.g. inner or outer pixels for 
 // the MAGIC camera), can be retrieved via: 
-// MCalibrationRelTimePix &avpix = (MCalibrationRelTimePix&)fRelCam->GetAverageArea(i)
+// MCalibrationQEPix &avpix = (MCalibrationQEPix&)fRelCam->GetAverageArea(i)
 //
 // Averaged values over one whole camera sector can be retrieved via: 
-// MCalibrationRelTimePix &avpix = (MCalibrationRelTimePix&)fRelCam->GetAverageSector(i)
-//
-// Note the averageing has been done at the end of the calculation and NOT on an 
-// event-by-event basis (like in other classes deriving from MCalibrationCam). 
-//
-// See also: MHCalibrationChargePix, MHCalibrationChargeCam, MCalibrationChargeCalc
+// MCalibrationQEPix &avpix = (MCalibrationQEPix&)fRelCam->GetAverageSector(i)
+//
+// The following "calibration" constants can be retrieved from each pixel:
+// - GetQEBlindPixel ( const PulserColor_t color ): The mean quantum 
+//   efficiency obtained with the calibration pulser color (e.g. kGREEN, kBLUE, kUV)
+//   after the Blind Pixel Method
+// - GetQEFFactor ( const PulserColor_t color ): The mean quantum 
+//   efficiency obtained with the calibration pulser color (e.g. kGREEN, kBLUE, kUV)
+//   after the F-Factor Method
+// - GetQEPINDiode ( const PulserColor_t color ): The mean quantum 
+//   efficiency obtained with the calibration pulser color (e.g. kGREEN, kBLUE, kUV)
+//   after the PIN Diode Method
+// - GetQECombined ( const PulserColor_t color ): The mean quantum 
+//   efficiency obtained with the calibration pulser color (e.g. kGREEN, kBLUE, kUV)
+//   after the combination of the three methods
+//
+// See also: MCalibrationQEPix, MCalibrationChargeCam, MCalibrationChargeCalc
+//           MCalibrationChargeBlindPix, MCalibrationChargePINDiode, MCalibrationChargePix
+//
 //                                                                         
 // The calculated values (types of GetPixelContent) are:
@@ -375,26 +385,50 @@
     {
     case 0:
-      val = pix.GetQEBlindPixel(kCT1);
+      val = pix.GetQECascadesFFactor();
       break;
     case 1:
-      val = pix.GetQEBlindPixelErr(kCT1);
+      val = pix.GetQECascadesFFactorErr();
       break;
     case 2:
-      val = pix.GetQEBlindPixel(kGREEN);
+      val = pix.GetQECascadesBlindPixel();
       break;
     case 3:
-      val = pix.GetQEBlindPixelErr(kGREEN);
+      val = pix.GetQECascadesBlindPixelErr();
       break;
     case 4:
-      val = pix.GetQEBlindPixel(kBLUE);
+      val = pix.GetQECascadesPINDiode();
       break;
     case 5:
-      val = pix.GetQEBlindPixelErr(kBLUE);
+      val = pix.GetQECascadesPINDiodeErr();
       break;
     case 6:
-      val = pix.GetQEBlindPixel(kUV);
+      val = pix.GetQECascadesCombined();
       break;
     case 7:
-      val = pix.GetQEBlindPixelErr(kUV);
+      val = pix.GetQECascadesCombinedErr();
+      break;
+    case 8:
+      val = pix.GetQEFFactor(kCT1);
+      break;
+    case 9:
+      val = pix.GetQEFFactorErr(kCT1);
+      break;
+    case 10:
+      val = pix.GetQEFFactor(kGREEN);
+      break;
+    case 11:
+      val = pix.GetQEFFactorErr(kGREEN);
+      break;
+    case 12:
+      val = pix.GetQEFFactor(kBLUE);
+      break;
+    case 13:
+      val = pix.GetQEFFactorErr(kBLUE);
+      break;
+    case 14:
+      val = pix.GetQEFFactor(kUV);
+      break;
+    case 15:
+      val = pix.GetQEFFactorErr(kUV);
       break;
     default: