Index: trunk/MagicSoft/Mars/mcalib/MCalibrationQEPix.h
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MCalibrationQEPix.h	(revision 3722)
+++ trunk/MagicSoft/Mars/mcalib/MCalibrationQEPix.h	(revision 3723)
@@ -122,8 +122,8 @@
 
   // Setters 
-  void SetAverageQEBlindPixelAvailable   ( const Bool_t b );
-  void SetAverageQECombinedAvailable     ( const Bool_t b );
-  void SetAverageQEFFactorAvailable      ( const Bool_t b );
-  void SetAverageQEPINDiodeAvailable     ( const Bool_t b );
+  void SetAverageQEBlindPixelAvailable   ( const Bool_t b=kTRUE );
+  void SetAverageQECombinedAvailable     ( const Bool_t b=kTRUE );
+  void SetAverageQEFFactorAvailable      ( const Bool_t b=kTRUE );
+  void SetAverageQEPINDiodeAvailable     ( const Bool_t b=kTRUE );
   void SetBlindPixelMethodValid          ( const Bool_t b, const MCalibrationCam::PulserColor_t col);
   void SetCombinedMethodValid            ( const Bool_t b, const MCalibrationCam::PulserColor_t col);
Index: trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.cc	(revision 3722)
+++ trunk/MagicSoft/Mars/mcalib/MHCalibrationCam.cc	(revision 3723)
@@ -400,4 +400,5 @@
   if (!fBadPixels)
     {
+
       fBadPixels = (MBadPixelsCam*)pList->FindCreateObj(AddSerialNumber("MBadPixelsCam"));
       if (!fBadPixels)
@@ -547,5 +548,5 @@
   if (bad.IsBad())
     hist.SetExcluded();
-
+  
   hist.InitBins();
   hist.ChangeHistId(i);
Index: trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeBlindPix.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeBlindPix.cc	(revision 3722)
+++ trunk/MagicSoft/Mars/mcalib/MHCalibrationChargeBlindPix.cc	(revision 3723)
@@ -424,4 +424,6 @@
   fBlindPix->SetOscillating  ( !IsFourierSpectrumOK() );
 
+  fBlindPix->SetValid(kTRUE);
+
   fMeanPedestal     = fSignal->GetPed();
   fMeanPedestalErr  = fSignal->GetPedErr();
@@ -437,7 +439,9 @@
 
   FitPedestal();
-  
+
   if (FitSinglePhe())
-      fBlindPix->SetSinglePheFitOK();
+    fBlindPix->SetSinglePheFitOK();
+  else
+    fBlindPix->SetValid(kFALSE);
 
   fBlindPix->SetLambda      (    fLambda               );
Index: trunk/MagicSoft/Mars/mcalib/MHCalibrationChargePINDiode.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MHCalibrationChargePINDiode.cc	(revision 3722)
+++ trunk/MagicSoft/Mars/mcalib/MHCalibrationChargePINDiode.cc	(revision 3723)
@@ -284,4 +284,6 @@
   fPINDiode->SetRmsChargeSigmaErr( GetRmsChargeSigmaErr()    );
 
+  fPINDiode->SetValid(kTRUE);
+
   const Byte_t  loweredge  = fSigPIN->GetFirstUsedSlice();
   const Byte_t  upperedge  = fSigPIN->GetLastUsedSlice();
@@ -291,16 +293,18 @@
   if (GetAbsTimeMean() < lowerlimit)
     {
-      *fLog << warn << GetDescriptor() << ": Mean ArrivalTime in first " << fTimeLowerLimit 
-            << " extraction bin in PIN Diode " << endl;
-      *fLog << GetAbsTimeMean() << "   " << lowerlimit << endl;
-      return kFALSE;
+      *fLog << warn << GetDescriptor() 
+            << Form("%s%3.1f%s%2.1f%s",": Mean ArrivalTime: ",GetAbsTimeMean()," smaller than ",
+                    lowerlimit," FADC slices from lower edge in PIN Diode") << endl;
+      *fLog << warn << GetDescriptor() << ": No PIN Diode calibration!! " << endl;
+      fPINDiode->SetValid(kFALSE);
     }
   
   if ( GetAbsTimeMean() > upperlimit )
     {
-      *fLog << warn << GetDescriptor() << ": Mean ArrivalTime in last " << fTimeUpperLimit 
-            << " two extraction bins in PIN Diode " << endl;
-      *fLog << GetAbsTimeMean() << "   " << upperlimit << endl;
-      return kFALSE;
+      *fLog << warn << GetDescriptor() 
+            << Form("%s%3.1f%s%2.1f%s",": Mean ArrivalTime: ",GetAbsTimeMean()," bigger than ",
+                    upperlimit," FADC slices from upper edge in PIN Diode") << endl;
+      *fLog << warn << GetDescriptor() << ": No PIN Diode calibration!! " << endl;
+      fPINDiode->SetValid(kFALSE);
     }
 