Index: trunk/MagicSoft/Mars/mcalib/MHCalibrationRelTimeCam.cc
===================================================================
--- trunk/MagicSoft/Mars/mcalib/MHCalibrationRelTimeCam.cc	(revision 3731)
+++ trunk/MagicSoft/Mars/mcalib/MHCalibrationRelTimeCam.cc	(revision 3738)
@@ -182,5 +182,6 @@
       for (Int_t i=0; i<npixels; i++)
       {
-	  (*fHiGainArray)[i] = new MHCalibrationRelTimePix;
+	  (*fHiGainArray)[i] = new MHCalibrationRelTimePix("MHCalibrationRelTimePixHiGain",
+                                                          "Relative Arrival Time High Gain Pixel");
           InitHists((*this)[i],(*fBadPixels)[i],i);
       }
@@ -192,5 +193,6 @@
       for (Int_t i=0; i<npixels; i++)
       {
-	  (*fLoGainArray)[i] = new MHCalibrationRelTimePix;
+	  (*fLoGainArray)[i] = new MHCalibrationRelTimePix("MHCalibrationRelTimePixLoGain",
+                                                          "Relative Arrival Time Low Gain Pixel");
           InitHists((*this)(i),(*fBadPixels)[i],i);
       }
@@ -204,11 +206,11 @@
       {
         (*fAverageHiGainAreas)[j] = 
-          new MHCalibrationRelTimePix("AverageHiGainArea",
-                                      "Average Relative Arrival Times area idx ");
+          new MHCalibrationRelTimePix("MHCalibrationRelTimeAverageAreaHiGain",
+                                      "Average Relative Arrival Times High Gain Area Idx ");
+
+        GetAverageHiGainArea(j).GetHGausHist()->SetTitle("Relative Arrival Times HiGain Area Idx ");
+        GetAverageHiGainArea(j).SetNbins(fAverageNbins);
 
         InitHists(GetAverageHiGainArea(j),fCam->GetAverageBadArea(j),j);
-
-        GetAverageHiGainArea(j).GetHGausHist()->SetTitle("Relative Arrival Times average Area Idx ");
-        GetAverageHiGainArea(j).SetNbins(fAverageNbins);
       }
   }
@@ -221,11 +223,11 @@
       {
         (*fAverageLoGainAreas)[j] = 
-          new MHCalibrationRelTimePix("AverageLoGainArea",
-                                      "Relative Arrival Times average Area idx ");
+          new MHCalibrationRelTimePix("MHCalibrationRelTimeAverageAreaLoGain",
+                                      "Average Relative Arrival Times Low Gain Area Idx ");
+
+        GetAverageLoGainArea(j).GetHGausHist()->SetTitle("Relative Arrival Times LoGain Area Idx ");
+        GetAverageLoGainArea(j).SetNbins(fAverageNbins);
 
         InitHists(GetAverageLoGainArea(j),fCam->GetAverageBadArea(j),j);
-
-        GetAverageLoGainArea(j).GetHGausHist()->SetTitle("Relative Arrival Times average Area Idx ");
-        GetAverageLoGainArea(j).SetNbins(fAverageNbins);
       }
   }
@@ -238,11 +240,11 @@
       {
 	  (*fAverageHiGainSectors)[j] = 
-            new MHCalibrationRelTimePix("AverageHiGainSector",
-                                        "Relative Arrival Times average sector ");
+            new MHCalibrationRelTimePix("MHCalibrationRelTimeAverageSectorHiGain",
+                                        "Average Relative Arrival Times High Gain Sector ");
+
+          GetAverageHiGainSector(j).GetHGausHist()->SetTitle("Relative Arrival Times HiGain Sector ");
+          GetAverageHiGainSector(j).SetNbins(fAverageNbins);
 
           InitHists(GetAverageHiGainSector(j),fCam->GetAverageBadSector(j),j);
-
-          GetAverageHiGainSector(j).GetHGausHist()->SetTitle("Relative Arrival Times average Sector ");
-          GetAverageHiGainSector(j).SetNbins(fAverageNbins);
       }
   }
@@ -255,11 +257,12 @@
       {
 	  (*fAverageLoGainSectors)[j] = 
-            new MHCalibrationRelTimePix("AverageLoGainSector",
-                                        "Relative Arrival Times average sector ");
+            new MHCalibrationRelTimePix("MHCalibrationRelTimeAverageSectorLoGain",
+                                        "Average Relative Arrival Times Low Gain Sector ");
+
+          GetAverageLoGainSector(j).GetHGausHist()->SetTitle("Relative Arrival Times LoGain Sector ");
+          GetAverageLoGainSector(j).SetNbins(fAverageNbins);
 
           InitHists(GetAverageLoGainSector(j),fCam->GetAverageBadSector(j),j);
           
-          GetAverageLoGainSector(j).GetHGausHist()->SetTitle("Relative Arrival Times average Sector ");
-          GetAverageLoGainSector(j).SetNbins(fAverageNbins);
       }
   }