Index: trunk/MagicSoft/Mars/mhbase/MBinning.cc
===================================================================
--- trunk/MagicSoft/Mars/mhbase/MBinning.cc	(revision 3583)
+++ trunk/MagicSoft/Mars/mhbase/MBinning.cc	(revision 3788)
@@ -61,8 +61,15 @@
 
     SetEdges(10, 0, 1);
-
     fType = kIsDefault;
 }
 
+MBinning::MBinning(Int_t nbins, Axis_t lo, Axis_t hi, const char *name, const char *opt="", const char *title=NULL)
+{
+    fName  = name  ? name  : gsDefName.Data();
+    fTitle = title ? title : gsDefTitle.Data();
+
+    SetEdges(nbins, lo, hi, opt);
+
+}
 void MBinning::SetEdges(const TAxis &axe)
 {
@@ -110,4 +117,26 @@
 
     fType = kIsLinear;
+}
+
+// --------------------------------------------------------------------------
+//
+// Calls SetEdgesLog if opt contains "log"
+// Calls SetEdgesCos if opt contains "cos"
+// Calls SetEdges in all other cases
+//
+void MBinning::SetEdges(const Int_t nbins, const Axis_t lo, Axis_t up, const char *opt)
+{
+    const TString o(opt);
+    if (o.Contains("log", TString::kIgnoreCase))
+    {
+        SetEdgesLog(nbins, lo, up);
+        return;
+    }
+    if (o.Contains("cos", TString::kIgnoreCase))
+    {
+        SetEdgesCos(nbins, lo, up);
+        return;
+    }
+    SetEdges(nbins, lo, up);
 }
 
Index: trunk/MagicSoft/Mars/mhbase/MBinning.h
===================================================================
--- trunk/MagicSoft/Mars/mhbase/MBinning.h	(revision 3583)
+++ trunk/MagicSoft/Mars/mhbase/MBinning.h	(revision 3788)
@@ -32,4 +32,5 @@
 public:
     MBinning(const char *name=NULL, const char *title=NULL);
+    MBinning(Int_t nbins, Axis_t lo, Axis_t hi, const char *name, const char *opt="", const char *title=NULL);
 
     void SetEdges(const TArrayD &arr)
@@ -42,4 +43,5 @@
     void SetEdges(const TH1 &h, const Char_t axis='x');
     void SetEdges(const Int_t nbins, const Axis_t lo, Axis_t up);
+    void SetEdges(const Int_t nbins, const Axis_t lo, Axis_t up, const char *opt);
     void SetEdgesLog(const Int_t nbins, const Axis_t lo, Axis_t up);
     void SetEdgesCos(const Int_t nbins, const Axis_t lo, Axis_t up);
Index: trunk/MagicSoft/Mars/mhbase/MFillH.cc
===================================================================
--- trunk/MagicSoft/Mars/mhbase/MFillH.cc	(revision 3583)
+++ trunk/MagicSoft/Mars/mhbase/MFillH.cc	(revision 3788)
@@ -340,4 +340,14 @@
 // --------------------------------------------------------------------------
 //
+// Use this to set a draw option used when drawing automatically to the
+// status display.
+//
+void MFillH::SetDrawOption(Option_t *option="")
+{
+    fDrawOption = option;
+}
+
+// --------------------------------------------------------------------------
+//
 // Creates a new tab in a status display with the name of the MH class,
 // if fDisplay is set and the MH-class overwrites the Draw function
@@ -357,5 +367,5 @@
 
     fCanvas = &fDisplay->AddTab(fNameTab.IsNull() ? fH->GetName() : fNameTab.Data());
-    fH->Draw();
+    fH->Draw(fDrawOption);
 
     return kTRUE;
@@ -549,6 +559,7 @@
     if (fDisplay && fDisplay->HasCanvas(fCanvas))
     {
+        const TString opt(Form("nonew %s", fDrawOption));
         fCanvas->cd();
-        fH->DrawClone("nonew");
+        fH->DrawClone(opt);
         fCanvas->Modified();
         fCanvas->Update();
Index: trunk/MagicSoft/Mars/mhbase/MFillH.h
===================================================================
--- trunk/MagicSoft/Mars/mhbase/MFillH.h	(revision 3583)
+++ trunk/MagicSoft/Mars/mhbase/MFillH.h	(revision 3788)
@@ -38,4 +38,6 @@
     TCanvas *fCanvas;             //! Canvas used to update a MStatusDisplay at the end of a loop
 
+    TString fDrawOption;          // Draw option for status display
+
     TString ExtractName(const char *name) const;
     TString ExtractClass(const char *name) const;
@@ -63,4 +65,7 @@
     void SetWeight(const char *name) { fWeightName = name; }
 
+    void      SetDrawOption(Option_t *option="");
+    Option_t *GetDrawOption() const { return fDrawOption; }
+
     Int_t  PreProcess(MParList *pList);
     Bool_t ReInit(MParList *pList);